!----------------------------------------------------
C     15.08.2010
!-----------------------------------------------------
* Program : SuSeFLAV: Supersymmetry seesaw and flavor violation calculator
* Version : 1.0
* Website : http://cts.iisc.ernet.in/Suseflav/main.html
* Authors : Debtosh Choudhury  debtosh@cts.iisc.ernet.in 
*           Raghuveer Garani   rgarani@cts.iisc.ernet.in
*           Sudhir Vempati     vempati@cts.iisc.ernet.in

      SUBROUTINE printslha(errge,flags,msusyold,murge,mAm3,
     $     MT,mb,mtau,MW,MZ,mh1mz,
     $     mh2mz,yuRG,ydRG,yeRG,
     $     AURG,ADRG,AERG,ON,OCL,OCR,alph3,alph2,
     $     alph1,M1tz,M2tz,M3tz,M3t,thetat,thetab,thetatau,
     $     mh0sq,mHu0sq,mA0sq,mhpmsq,SUegg,SDegg,SLegg,SNegg,Neg,Ceg,
     $     mSQRG,mSURG,mSDRG,mSLRG,mSERG,USL,ftmz,ftmt)

      
      implicit double precision (a-h,m,o-z)
      character*100 flags
      INTEGER lhaout,o1pos,o2pos,o3pos,o4pos,checkpi2,errge
      INTEGER lopt, rhn
      double precision extpar(0:60)
      character charprn(1:20)*20,softpar(0:60)*20

      CHARACTER*4 model
      CHARACTER*8 mrhn
      CHARACTER*3 case
      DOUBLE PRECISION m0, m12, a0, tanbeta, sgnmu
      DOUBLE PRECISION msusyold, murge, mAm3, MT, mb, mtau
      DOUBLE PRECISION  mh1mz, mh2mz, vev1n,vev2n
      DOUBLE PRECISION alph3, alph2, alph1, M1tz, M2tz, M3tz
      DOUBLE PRECISION thetat, thetab, thetatau, M3t
      DOUBLE PRECISION ON(4,4),OCL(2,2),OCR(2,2)
      DOUBLE PRECISION AURG(3,3),ADRG(3,3),AERG(3,3)
      DOUBLE PRECISION yuRG(3,3),ydRG(3,3),yeRG(3,3)
      DOUBLE PRECISION mh0sq, mA0sq, mhpmsq, mHu0sq
      DOUBLE PRECISION  Ceg(2),Neg(4)!, Mneut(4), Mchar(2)
      DOUBLE PRECISION SUegg(6),SDegg(6),SLegg(6),SNegg(3),mSERG(3,3)
      DOUBLE PRECISION mSQRG(3,3),mSURG(3,3),mSDRG(3,3),mSLRG(3,3)
      DOUBLE PRECISION OCRTm(2,2),OCLm(2,2),ONew(4,4)
      DOUBLE PRECISION o1,o2,o3,o4,ONtemp(4,4),negarray(4),USL(6,6)
        
      DOUBLE PRECISION MSQU3(2,2),MSQD3(2,2),MSQE3(2,2),
     $     th1,th2,th3,th4

!      double precision rrstaumu(2),USLsrt(6,6),USLTsrt(6,6)

      double precision sw2, gnuL,gul,gur,gdl,gdr,gel,ger,beta
      integer num,modnum,smnum(10),minparnum(10),counter_sminp
      integer counter_minpar,counter_algopar,algonum(20)
      double precision sminp(10), minpar(10), algopar(20)

      DOUBLE PRECISION  alph,Gf,alphas
      DOUBLE PRECISION gmsbsusyb, gmsbmess,gr,nhat
      DOUBLE PRECISION s1,s2,s3,s4
      DOUBLE PRECISION drho,gm2,Bbsg,bmeg,brmu3e,btmug,brtau3mu,
     $     bteg,brtau3e, ftmz,ftmt,gravitino
      DOUBLE PRECISION o1s,o2s,o3s,o4s
      DOUBLE PRECISION USLvd(6,6),USUvd(6,6),USDvd(6,6)
      DOUBLE PRECISION SLegvd(6),SUegvd(6),SDegvd(6)
!----------------------------------
      common/sminputs/ mbpole, mtaupole, Mpole
      common/opt_mixing/OCRTm, OCLm, ONew, alpha
      common/vev_ewsb/ vev1n,vev2n
!      common/mutaup/rrstaumu,USLsrt,USLTsrt
      common/mssminputs/ m0, m12, m10, m20, sgnmu, tanbeta, a0
      common/gauge/alph,Gf,alphas
      common/charinputs/case, model
      common/gmsbinputs/ gmsbsusyb, gmsbmess,gr,nhat

      common/lowepar/drho,gm2,Bbsg,bmeg,brmu3e,btmug,brtau3mu,
     $     bteg,brtau3e

      common/lfvmixing/USLvd,USUvd,USDvd
      common/lfveigval/SLegvd,SUegvd,SDegvd


!---SLHA common blocks---

      common/loops/ lopt,rhn
      common/slha_modsel/num, modnum
      common/slha_counters/counter_sminp,counter_minpar,counter_algopar
      common/slha_num/smnum,minparnum,algonum
      common/slha_variables/sminp,minpar,algopar
      common/m32/gravitino

!--------------------------------------------------------------------------------
      include 'stdinputs.h'
 
      lhaout = 2

      OPEN(lhaout, FILE = 'slha.out',ACCESS = 'APPEND',
     $     STATUS = 'replace')

!----------------------------------------------
C     

      sw2 = 1.d0 - (MW / MZ)**2.d0
      gnuL = 0.5d0
      guL = 0.5d0 - 2.d0*sw2/ 3.d0 
      gdL = -0.5d0 + sw2/3.d0
      geL = -0.5d0 + sw2
      guR =  2.d0*sw2/3.d0 
      gdR = -sw2/3.d0
      geR = -sw2 

      beta = datan(tanbeta)


C     for stop

      MSQU3(1,1) = mSQRG(3,3) + MT**2.d0 + 
     $           guL*MZ*MZ*dcos(2.d0*beta)

      MSQU3(1,2) = MT*((AURG(3,3) - murge/tanbeta))

      MSQU3(2,1) = MSQU3(1,2)

      MSQU3(2,2) = mSURG(3,3) + MT**2.d0 + 
     $     guR*MZ*MZ*dcos(2.d0*beta)



C     for sbottom

      MSQD3(1,1) = mSQRG(3,3) + MB**2.d0 + 
     $     gdL*MZ*MZ*dcos(2.d0*beta)

      MSQD3(1,2) = MB*((ADRG(3,3) - murge*tanbeta))
      MSQD3(2,1) = MSQD3(1,2)

      MSQD3(2,2) = mSDRG(3,3) + MB**2.d0 + 
     $     gdR*MZ*MZ*dcos(2.d0*beta)



C     for stau

      MSQE3(1,1) = mSLRG(3,3) + MTAU**2.d0 + 
     $     geL*MZ*MZ*dcos(2.d0*beta)
      MSQE3(1,2) = MTAU*((AERG(3,3) - murge*dtan(beta)))
      MSQE3(2,1) = MSQE3(1,2)
      MSQE3(2,2) = mSERG(3,3) + MTAU**2.d0 + 
     $     geR*MZ*MZ*dcos(2.d0*beta)



      thetat   = 0.d0 + 
     $     datan((2.d0*MSQU3(1,2))/(MSQU3(1,1)-MSQU3(2,2)))*0.5d0

      thetab   = 0.d0 + 
     $     datan((2.d0*MSQD3(1,2))/(MSQD3(1,1)-MSQD3(2,2)))*0.5d0

      thetatau = 0.d0 + 
     $     datan((2.d0*MSQE3(1,2))/(MSQE3(1,1)-MSQE3(2,2)))*0.5d0



      if(MSQE3(1,1).gt.MSQE3(2,2))then
         thetatau = thetatau + pi/2.d0
         checkpi2 = 1

      endif

      if(MSQU3(1,1).gt.MSQU3(2,2))then
         thetat = thetat + pi/2.d0
      endif

      if(MSQD3(1,1).gt.MSQD3(2,2))then
         thetab = thetab + pi/2.d0
      endif

!-----------------------------------------------

        pi=4*datan(1.d0)

c PDG values:
      id =1
      idb=-1
      iu =2
      iub=-2
      is =3
      isb=-3
      ic =4
      icb=-4
      ib =5
      ibb=-5
      it =6
      itb=-6

      ie   =11
      ine  =12
      imu  =13
      inmu =14
      itau =15
      intau=16

      ihl=25
      ihh=35
      iha=36
      ihc=37
      igl=21
      iga=22
      iz =23
      iwc=24

      isdl=1000001
      isdr=2000001
      isul=1000002
      isur=2000002
      issl=1000003
      issr=2000003
      iscl=1000004
      iscr=2000004
      isb1=1000005
      isb2=2000005
      ist1=1000006
      ist2=2000006

      iglo=1000021
      in1 =1000022
      in2 =1000023
      in3 =1000025
      in4 =1000035
      ic1 =1000024
      ic2 =1000037

      intau1=1000016 
      intau2=2000016 
      inel  =1000012
      iner  =2000012
      inmul =1000014
      inmur =2000014
      
      isell =1000011
      iselr =2000011
      ismul =1000013
      ismur =2000013
      istau1=1000015
      istau2=2000015

      igrav =1000039
!---------------------------------      
      charprn(3) = ' tanbeta'
      charprn(4) = ' sign(mu)'

c input for msugra models
      if(model.eq.'mSUG')then
      charprn(1) = ' m0'
      charprn(2) = ' m_1/2'
      charprn(5) = ' A0'
      else if(model.eq.'GMSB')then
c    input for GMSB models:
      charprn(1) = ' Lambda_susy'
      charprn(2) = ' Lambda_mess'
      charprn(5) = ' N_mess'  
      charprn(6) = ' c_grav'
      else if(model.eq.'NUHM')then
      charprn(1) = ' m0'
      charprn(2) = ' m_1/2'
      charprn(5) = ' A0'
      charprn(6) = ' m10'
      charprn(7) = ' m20'

      endif
            
c  SOFTPAR :
        softpar(0) = ' EWSB scale'          
        softpar(10) = ' GUT scale'
	softpar(23) = ' mu(EWSB)'
	softpar(24) = ' m^2_A_run(EWSB)'
        softpar(25) = ' tanbeta(in)'
	softpar(26) = ' MA_pole'
        softpar(1) = ' M_1'
        softpar(2) = ' M_2'
        softpar(3) = ' M_3'
        softpar(21) = ' M^2_Hd'
        softpar(22) = ' M^2_Hu'
        softpar(31) = ' M_eL'
        softpar(32) = ' M_muL'
        softpar(33) = ' M_tauL'
        softpar(34) = ' M_eR'
        softpar(35) = ' M_muR'
        softpar(36) = ' M_tauR'
        softpar(41) = ' M_q1L'
        softpar(42) = ' M_q2L'
        softpar(43) = ' M_q3L'
        softpar(44) = ' M_uR'
        softpar(45) = ' M_cR'
        softpar(46) = ' M_tR'
        softpar(47) = ' M_dR'
        softpar(48) = ' M_sR'
        softpar(49) = ' M_bR'
        softpar(11) = ' A_t'
        softpar(12) = ' A_b'
        softpar(13) = ' A_tau'
        softpar(14) = ' A_u'
        softpar(15) = ' A_d'
        softpar(16) = ' A_e'

        scale = msusyold
!--------------------------------------------------------
        if(neg(1).lt.0.d0)then
           s1 = -1.d0
        else
           s1 = 1.d0
        endif

        if(neg(2).lt.0.d0)then
           s2 = -1.d0
        else
           s2 = 1.d0
        endif

        if(neg(3).lt.0.d0)then
           s3 = -1.d0
        else
           s3 = 1.d0
        endif

        if(neg(4).lt.0.d0)then
           s4 = -1.d0
        else
           s4 = 1.d0
        endif


        negarray(1) = dabs(neg(1))
        negarray(2) = dabs(neg(2))
        negarray(3) = dabs(neg(3))
        negarray(4) = dabs(neg(4))


        o1pos = MINLOC(negarray, DIM =1)
        o1 =  MINVAL(negarray, dim=1)

     
        o2pos = MINLOC(negarray, DIM = 1,MASK = negarray.gt.o1)
        o2 =   MINVAL(negarray, DIM = 1,MASK = negarray.gt.o1)

        o3pos = MINLOC(negarray, DIM = 1,MASK = negarray.gt.o2)
        o3 =   MINVAL(negarray, DIM = 1,MASK = negarray.gt.o2)

        o4pos = MINLOC(negarray, DIM = 1,MASK = negarray.gt.o3)
        o4 =  MINVAL(negarray, DIM = 1,MASK = negarray.gt.o3)

        if(dabs(o1).eq.dabs(neg(1)))then
           o1s = s1 * o1
        elseif(dabs(o1).eq.dabs(neg(2)))then
           o1s = s2 * o1
        elseif(dabs(o1).eq.dabs(neg(3)))then
           o1s = s3 * o1
        elseif(dabs(o1).eq.dabs(neg(4)))then
           o1s = s4 * o1
        endif

        if(dabs(o2).eq.dabs(neg(1)))then
           o2s = s1 * o2
        elseif(dabs(o2).eq.dabs(neg(2)))then
           o2s = s2 * o2
        elseif(dabs(o2).eq.dabs(neg(3)))then
           o2s = s3 * o2
        elseif(dabs(o2).eq.dabs(neg(4)))then
           o2s = s4 * o2
        endif

        if(dabs(o3).eq.dabs(neg(1)))then
           o3s = s1 * o3
        elseif(dabs(o3).eq.dabs(neg(2)))then
           o3s = s2 * o3
        elseif(dabs(o3).eq.dabs(neg(3)))then
           o3s = s3 * o3
        elseif(dabs(o3).eq.dabs(neg(4)))then
           o3s = s4 * o3
        endif


        if(dabs(o4).eq.dabs(neg(1)))then
           o4s = s1 * o4
        elseif(dabs(o4).eq.dabs(neg(2)))then
           o4s = s2 * o4
        elseif(dabs(o4).eq.dabs(neg(3)))then
           o4s = s3 * o4
        elseif(dabs(o4).eq.dabs(neg(4)))then
           o4s = s4 * o4
        endif
!----------------------------------------

        do i = 1,4
        ONtemp(i,1) = ON(o1pos,i)
        ONtemp(i,2) = ON(o2pos,i)
        ONtemp(i,3) = ON(o3pos,i)
        ONtemp(i,4) = ON(o4pos,i)

        enddo

        do i = 1,4

           ONew(i,1) = ONtemp(i,1)
           ONew(i,2) = ONtemp(i,2)
           ONew(i,3) = ONtemp(i,3)
           ONew(i,4) = ONtemp(i,4)


           enddo

      if(model.eq.'mSUG')then
         modnum = 0
         mrhn = 'mSUG+RHN'
      endif

      if(model.eq.'GMSB')then
         modnum = 1
         mrhn = 'GMSB+RHN'
      endif

      if(model.eq.'NUHM')then
         modnum = 2
         mrhn = 'NUHM+RHN'
      endif

!---------------writing begins

      write(lhaout,105)
      write(lhaout,51) 'SPINFO',' Program information'
      write(lhaout,61) 1,'SuSeFLAV     # Spectrum calculator'
      write(lhaout,61) 2,'1.0          # version number'

      write(lhaout,105)
      if(rhn.eq.0)then
      write(lhaout,51) 'MODSEL',' MODEL NAME'
      write(lhaout,611) 1, modnum , model
      elseif(rhn.eq.1)then
      write(lhaout,51) 'MODSEL',' MODEL NAME'
      write(lhaout,611) 1, modnum , mrhn
      endif
            
      if(model.eq.'GMSB')then

      write(lhaout,105)
      write(lhaout,51) 'MINPAR','Input parameters'
      write(lhaout,52) 1, gmsbsusyb ,charprn(1)
      write(lhaout,52) 2, gmsbmess ,charprn(2)
      write(lhaout,52) 3, tanbeta ,charprn(3)
      write(lhaout,52) 4, sgnmu ,charprn(4)
      write(lhaout,52) 5, nhat ,charprn(5)      
      write(lhaout,52) 6, gr ,charprn(6)

      else if(model.eq.'mSUG')then
 
      write(lhaout,105)
      write(lhaout,51) 'MINPAR','Input parameters'
      write(lhaout,52) 1, m0 ,charprn(1)
      write(lhaout,52) 2, m12 ,charprn(2)
      write(lhaout,52) 3, tanbeta ,charprn(3)
      write(lhaout,52) 4, sgnmu ,charprn(4)
      write(lhaout,52) 5, a0 ,charprn(5)

      else if(model.eq.'NUHM')then

      write(lhaout,105)
      write(lhaout,51) 'MINPAR','Input parameters'
      write(lhaout,52) 1, m0 ,charprn(1)
      write(lhaout,52) 2, m12 ,charprn(2)
      write(lhaout,52) 3, tanbeta ,charprn(3)
      write(lhaout,52) 4, sgnmu ,charprn(4)
      write(lhaout,52) 5, a0 ,charprn(5)
      write(lhaout,52) 6, m10 ,charprn(6)
      write(lhaout,52) 7, m20 ,charprn(7)

      endif

c ----------------------- c
c The SM input parameters c
c ----------------------- c

      write(lhaout,105)
      write(lhaout,51) 'SMINPUTS','Standard Model inputs'
      write(lhaout,52) 1, 1/alph  ,'alpha_em (M_Z)^MSbar'
      write(lhaout,52) 2, Gf    ,'G_F [GeV^-2]'
      write(lhaout,52) 3, alphas,'alpha_S(M_Z)^MSbar'
      write(lhaout,52) 4, MZ    ,'M_Z pole mass'
      write(lhaout,52) 5, mbpole    ,'mb(mb)^MSbar'
      write(lhaout,52) 6, Mpole    ,'mt pole mass'
      write(lhaout,52) 7, mtaupole  ,'mtau pole mass'

      errspec: if(errge.eq.1)then
         write(lhaout,*),"Invalid point ", flags
         
         else errspec
 
c$$$	 if(ichoice(1).ge.10) then
      write(lhaout,105)
      write(lhaout,51) 'EXTPAR','Input parameters'
c$$$      if(ichoice(8).eq.1) 
      extpar(0) = scale
      softpar(0) ='EWSB scale'
      write(lhaout,72) 0,extpar(0),softpar(0)

c ----------------- c
c The mass spectrum c
c ----------------- c

      write(lhaout,105)
      write(lhaout,51) 'MASS','Mass Spectrum'
      write(lhaout,50) 'PDG code           mass       particle'
      write(lhaout,52) iwc,MW,'W+'
      write(lhaout,52) ihl,dsqrt(mh0sq),'h'
      write(lhaout,52) ihh,dsqrt(mHu0sq),'H'
      write(lhaout,52) iha,dsqrt(mA0sq),'A'
      write(lhaout,52) ihc,dsqrt(mhpmsq),'H+'
      write(lhaout,52) ib,mbpole,'b pole mass calculated 
     $from mb(mb)_MSbar'
c$$$      write(lhaout,52) isdl,dsqrt(SDegg(5)),'~d_L'
c$$$      write(lhaout,52) isdr,dsqrt(SDegg(6)),'~d_R'
c$$$      write(lhaout,52) isul,dsqrt(SUegg(5)),'~u_L'
c$$$      write(lhaout,52) isur,dsqrt(SUegg(6)),'~u_R'
c$$$      write(lhaout,52) issl,dsqrt(SDegg(3)),'~s_L'
c$$$      write(lhaout,52) issr,dsqrt(SDegg(4)),'~s_R'
c$$$      write(lhaout,52) iscl,dsqrt(SUegg(3)),'~c_L'
c$$$      write(lhaout,52) iscr,dsqrt(SUegg(4)),'~c_R'
c$$$      write(lhaout,52) isb1,dsqrt(SDegg(1)),
c$$$     $     '~b_1'
c$$$      write(lhaout,52) isb2,dsqrt(SDegg(2)),
c$$$     $     '~b_2'
c$$$      write(lhaout,52) ist1,dsqrt(SUegg(1)),
c$$$     $     '~t_1'
c$$$      write(lhaout,52) ist2,dsqrt(SUegg(2)),
c$$$     $     '~t_2'
c$$$      write(lhaout,52) isell,dsqrt(SLegg(5)),'~e_L'
c$$$      write(lhaout,52) iselr,dsqrt(SLegg(6)),'~e_R'
c$$$      write(lhaout,52) inel, dsqrt(SNegg(3)),'~nu_eL'
c$$$      write(lhaout,52) ismul,dsqrt(SLegg(3)),
c$$$     $     '~mu_L'
c$$$      write(lhaout,52) ismur,dsqrt(SLegg(4)),
c$$$     $     '~mu_R'
c$$$      write(lhaout,52) inmul,dsqrt(SNegg(2)),'~nu_muL'
c$$$      write(lhaout,52) istau1,dsqrt(SLegg(1)),
c$$$     $     '~tau_1'
c$$$      write(lhaout,52) istau2,dsqrt(SLegg(2)),
c$$$     $     '~tau_2'
c$$$      write(lhaout,52) intau1,dsqrt(SNegg(1)),'~nu_tauL'

      write(lhaout,52) isdl,dsqrt(SDegvd(1)),'~d_1'
      write(lhaout,52) issl,dsqrt(SDegvd(2)),'~d_2'
      write(lhaout,52) isb1,dsqrt(SDegvd(5)),'~d_3'
      write(lhaout,52) isdr,dsqrt(SDegvd(3)),'~d_4'
      write(lhaout,52) issr,dsqrt(SDegvd(4)),
     $     '~d_5'
      write(lhaout,52) isb2,dsqrt(SDegvd(6)),
     $     '~d_6'

      write(lhaout,52) isul,dsqrt(SUegvd(1)),'~u_1'
      write(lhaout,52) iscl,dsqrt(SUegvd(2)),'~u_2'
      write(lhaout,52) ist1,dsqrt(SUegvd(5)),'~u_3'
      write(lhaout,52) isur,dsqrt(SUegvd(3)),'~u_4'
      write(lhaout,52) iscr,dsqrt(SUegvd(4)),
     $     '~u_5'
      write(lhaout,52) ist2,dsqrt(SUegg(6)),
     $     '~u_6'

      write(lhaout,52) isell,dsqrt(SLegvd(1)),'~l_1'
      write(lhaout,52) ismul,dsqrt(SLegvd(2)),'~l_2'
      write(lhaout,52) istau1,dsqrt(SLegvd(5)),
     $     '~l_3'
      write(lhaout,52) iselr,dsqrt(SLegvd(3)),
     $     '~l_4'
      write(lhaout,52) ismur,dsqrt(SLegvd(4)),
     $     '~l_5'
      write(lhaout,52) istau2,dsqrt(SLegvd(6)),
     $     '~l_6'
 
      write(lhaout,52) inel, dsqrt(SNegg(3)),'~nu_eL'
      write(lhaout,52) inmul,dsqrt(SNegg(2)),'~nu_muL'
      write(lhaout,52) intau1,dsqrt(SNegg(1)),'~nu_tauL'


      write(lhaout,52) iglo,M3t,'~g'
      write(lhaout,522) in1,o1s,'~chi_10'
      write(lhaout,522) in2,o2s,'~chi_20'
      write(lhaout,522) in3,o3s,'~chi_30'
      write(lhaout,522) in4,o4s,'~chi_40'
      write(lhaout,52) ic1,ceg(1),'~chi_1+'
      write(lhaout,52) ic2,ceg(2),'~chi_2+'
      if(model.eq.'GMSB')then
      write(lhaout,52) igrav,gravitino,'~gravitino'
      endif


c  low energy parameters:
c
      write(lhaout,105)
      write(lhaout,51) 'LOW ENERGY ',' PARAMETERS '
      write(lhaout,52) 1,Drho,'Delta rho parameter'
      write(lhaout,52) 2,gm2,'g_mu -2'
      write(lhaout,52) 3,Bbsg,'Br(b -> s gamma)'
      write(lhaout,52) 4,Btmug,'Br(tau -> mu gamma)'
      write(lhaout,52) 5,Bteg,'Br(tau -> e gamma)'
      write(lhaout,52) 6,Bmeg,'Br(mu -> e gamma)'
      write(lhaout,52) 7,brtau3mu,'Br(tau -> mu mu mu)'
      write(lhaout,52) 8,brtau3e,'Br(tau -> e e e)'
      write(lhaout,52) 9,Brmu3e,'Br(mu -> e e e)'


c  fine-tuning parameters :
c
      write(lhaout,105)
      write(lhaout,51) 'FINETUNE','fine-tuned if >>1'
      write(lhaout,52) 1,ftmt,'delta mZ^2/mZ^2 (mu^2)'
      write(lhaout,52) 2,ftmz,'delta mt/mt (mu^2)'


c ------------------------------------------------------------------- c
c The neutralino mixing matrix N and the chargino mixing matrices U,V c
c ------------------------------------------------------------------- c
      
      write(lhaout,105)
      write(lhaout,51) 'NMIX','Neutralino Mixing Matrix'
      write(lhaout,53) 1,1,ONew(1,1),'N_11'
      write(lhaout,53) 1,2,ONew(1,2),'N_12'
      write(lhaout,53) 1,3,ONew(1,3),'N_13'
      write(lhaout,53) 1,4,ONew(1,4),'N_14'
      write(lhaout,53) 2,1,ONew(2,1),'N_21'
      write(lhaout,53) 2,2,ONew(2,2),'N_22'
      write(lhaout,53) 2,3,ONew(2,3),'N_23'
      write(lhaout,53) 2,4,ONew(2,4),'N_24'
      write(lhaout,53) 3,1,ONew(3,1),'N_31'
      write(lhaout,53) 3,2,ONew(3,2),'N_32'
      write(lhaout,53) 3,3,ONew(3,3),'N_33'
      write(lhaout,53) 3,4,ONew(3,4),'N_34'
      write(lhaout,53) 4,1,ONew(4,1),'N_41'
      write(lhaout,53) 4,2,ONew(4,2),'N_42'
      write(lhaout,53) 4,3,ONew(4,3),'N_43'
      write(lhaout,53) 4,4,ONew(4,4),'N_44'

      write(lhaout,105)
      write(lhaout,51) 'UMIX','Chargino Mixing Matrix U'
      write(lhaout,53) 1,1,OCLm(1,1),'U_11'
      write(lhaout,53) 1,2,OCLm(1,2),'U_12'
      write(lhaout,53) 2,1,OCLm(2,1),'U_21'
      write(lhaout,53) 2,2,OCLm(2,2),'U_22'

      write(lhaout,105)
      write(lhaout,51) 'VMIX','Chargino Mixing Matrix V'
      write(lhaout,53) 1,1,OCRTm(1,1),'V_11'
      write(lhaout,53) 1,2,OCRTm(1,2),'V_12'
      write(lhaout,53) 2,1,OCRTm(2,1),'V_21'
      write(lhaout,53) 2,2,OCRTm(2,2),'V_22'

c ------------------------------------------ c
c The stop, sbottom and stau mixing matrices c
c ------------------------------------------ c

      write(lhaout,105)
      write(lhaout,51) 'STOPMIX','Stop Mixing Matrix'
      write(lhaout,53) 1,1,dcos(thetat),'cos(theta_t)'
      write(lhaout,53) 1,2,dsin(thetat),'sin(theta_t)'
      write(lhaout,53) 2,1,-dsin(thetat),'-sin(theta_t)'
      write(lhaout,53) 2,2,dcos(thetat),'cos(theta_t)'

      write(lhaout,105)
      write(lhaout,51) 'SBOTMIX','Sbottom Mixing Matrix'
      write(lhaout,53) 1,1,dcos(thetab),'cos(theta_b)'
      write(lhaout,53) 1,2,dsin(thetab),'sin(theta_b)'
      write(lhaout,53) 2,1,-dsin(thetab),'-sin(theta_b)'
      write(lhaout,53) 2,2,dcos(thetab),'cos(theta_b)'


      write(lhaout,105)
      write(lhaout,51) 'STAUMIX','Stau Mixing Matrix'
      write(lhaout,53) 1,1,dcos(thetatau),'cos(theta_tau)'
      write(lhaout,53) 1,2,dsin(thetatau) ,'sin(theta_tau)'
      write(lhaout,53) 2,1,-dsin(thetatau),'-sin(theta_tau)'
      write(lhaout,53) 2,2,dcos(thetatau),'cos(theta_tau)'


c ------------------------------------------------------------------- c
c The angle alpha in the Higgs sector and the Higgs mixing parameters c
c ------------------------------------------------------------------- c

      write(lhaout,105)
      write(lhaout,51) 'ALPHA','Higgs mixing'
      write(lhaout,60) alpha,'Mixing angle in the neutral Higgs boson secto
     .r'

      write(lhaout,105)
      write(lhaout,54) 'HMIX Q=',scale,'DRbar Higgs Parameters'
      write(lhaout,55) 1,murge,'mu(Q)'
      write(lhaout,55) 2,vev2n/vev1n,'tanbeta(Q)'
      write(lhaout,55) 3,dsqrt(vev2n**2.d0 + vev1n**2.d0),'vev(Q)'
      write(lhaout,55) 4, mAm3 ,'MA^2(Q)'


c ------------------- c
c The gauge couplings c
c ------------------- c

      write(lhaout,105)      
      write(lhaout,54) 'GAUGE Q=',scale,'The gauge couplings'
      write(lhaout,55) 1,dsqrt(alph1*16.d0*pi*pi)*dsqrt(3.d0/5.d0),
     $     'gprime(Q) DRbar'
      write(lhaout,55) 2,dsqrt(alph2*16.d0*pi*pi),'g(Q) DRbar'
      write(lhaout,55) 3,dsqrt(alph3*16.d0*pi*pi),'g_3(Q) DRbar'
c ------------------------------------- c
c The trilinear couplings Au, Ad and Ae c
c ------------------------------------- c
      scalesave=scale
!      if(ichoice(1).eq.2) scale=ehigh
      write(lhaout,105)
      write(lhaout,54) 'Au Q=',scale,'The trilinear couplings'
      write(lhaout,53) 1,1,AURG(1,1), 'A_u(Q) DRbar'
      write(lhaout,53) 2,2,AURG(2,2), 'A_c(Q) DRbar'
      write(lhaout,53) 3,3,AURG(3,3),'A_t(Q) DRbar'

      write(lhaout,105)
      write(lhaout,54) 'Ad Q=',scale,'The trilinear couplings'
      write(lhaout,53) 1,1,ADRG(1,1),'A_d(Q) DRbar'
      write(lhaout,53) 2,2,ADRG(2,2),'A_s(Q) DRbar'
      write(lhaout,53) 3,3,ADRG(3,3),'A_b(Q) DRbar'

      write(lhaout,105)
      write(lhaout,54) 'Ae Q=',scale,'The trilinear couplings'
      write(lhaout,53) 1,1,AERG(1,1),'A_e(Q) DRbar'
      write(lhaout,53) 2,2,AERG(2,2),'A_mu(Q) DRbar'
      write(lhaout,53) 3,3,AERG(3,3),'A_tau(Q) DRbar'

c ---------------------------------- c
c The Yukawa couplings Yu, Yd and Ye c
c ---------------------------------- c

      write(lhaout,105)
      write(lhaout,54) 'Yu Q=',scalesave,'The Yukawa couplings'
         write(lhaout,53) 3,3,
     $     yuRG(3,3),'y_top(Q) DRbar'
c
      write(lhaout,105)
      write(lhaout,54) 'Yd Q=',scalesave,'The Yukawa couplings'
         write(lhaout,53) 3,3,
     $     ydRG(3,3),'y_b(Q) DRbar'
c
      write(lhaout,105)
      write(lhaout,54) 'Ye Q=',scalesave,'The Yukawa couplings'
         write(lhaout,53) 3,3,
     $     yeRG(3,3),'y_tau(Q) DRbar'


 
c ----------------------------- c
c The soft SUSY breaking masses c
c ----------------------------- c

      write(lhaout,105)
      write(lhaout,54) 'MSOFT Q=',scale,'soft SUSY breaking masses at the 
     .scale Q'
      write(lhaout,52) 1,M1tz,'M_1'
      write(lhaout,52) 2,M2tz,'M_2'
      write(lhaout,52) 3,M3tz,'M_3'
         write(lhaout,52) 21,mh2mz,'M^2_Hd'
         write(lhaout,52) 22,mh1mz,'M^2_Hu'
      write(lhaout,52) 31,dsqrt(mSLRG(1,1)),'M_eL'
      write(lhaout,52) 32,dsqrt(mSLRG(2,2)),'M_muL'
      write(lhaout,52) 33,dsqrt(mSLRG(3,3)),'M_tauL'
      write(lhaout,52) 34,dsqrt(mSERG(1,1)),'M_eR'
      write(lhaout,52) 35,dsqrt(mSERG(2,2)),'M_muR'
      write(lhaout,52) 36,dsqrt(mSERG(3,3)),'M_tauR'
      write(lhaout,52) 41,dsqrt(mSQRG(1,1)),'M_q1L'
      write(lhaout,52) 42,dsqrt(mSQRG(2,2)),'M_q2L'
      write(lhaout,52) 43,dsqrt(mSQRG(3,3)),'M_q3L'
      write(lhaout,52) 44,dsqrt(mSURG(1,1)),'M_uR'
      write(lhaout,52) 45,dsqrt(mSURG(2,2)),'M_cR'
      write(lhaout,52) 46,dsqrt(mSURG(3,3)),'M_tR'
      write(lhaout,52) 47,dsqrt(mSDRG(1,1)),'M_dR'
      write(lhaout,52) 48,dsqrt(mSDRG(2,2)),'M_sR'
      write(lhaout,52) 49,dsqrt(mSDRG(3,3)),'M_bR'


      write(lhaout,105)
      write(lhaout,51) 'USQMIX','squark Mixing Matrix'
      write(lhaout,53) 1,1,USUvd(1,1),'USQMIX_{11}'
      write(lhaout,53) 1,2,USUvd(2,1),'USQMIX_{12}'
      write(lhaout,53) 1,3,USUvd(3,1),'USQMIX_{13}'
      write(lhaout,53) 1,4,USUvd(4,1),'USQMIX_{14}'
      write(lhaout,53) 1,5,USUvd(5,1),'USQMIX_{15}'
      write(lhaout,53) 1,6,USUvd(6,1),'USQMIX_{16}'
      write(lhaout,53) 2,1,USUvd(1,2),'USQMIX_{21}'
      write(lhaout,53) 2,2,USUvd(2,2),'USQMIX_{22}'
      write(lhaout,53) 2,3,USUvd(3,2),'USQMIX_{23}'
      write(lhaout,53) 2,4,USUvd(4,2),'USQMIX_{24}'
      write(lhaout,53) 2,5,USUvd(5,2),'USQMIX_{25}'
      write(lhaout,53) 2,6,USUvd(6,2),'USQMIX_{26}'
      write(lhaout,53) 3,1,USUvd(1,3),'USQMIX_{31}'
      write(lhaout,53) 3,2,USUvd(2,3),'USQMIX_{32}'
      write(lhaout,53) 3,3,USUvd(3,3),'USQMIX_{33}'
      write(lhaout,53) 3,4,USUvd(4,3),'USQMIX_{34}'
      write(lhaout,53) 3,5,USUvd(5,3),'USQMIX_{35}'
      write(lhaout,53) 3,6,USUvd(6,3),'USQMIX_{36}'
      write(lhaout,53) 4,1,USUvd(1,4),'USQMIX_{41}'
      write(lhaout,53) 4,2,USUvd(2,4),'USQMIX_{42}'
      write(lhaout,53) 4,3,USUvd(3,4),'USQMIX_{43}'
      write(lhaout,53) 4,4,USUvd(4,4),'USQMIX_{44}'
      write(lhaout,53) 4,5,USUvd(5,4),'USQMIX_{45}'
      write(lhaout,53) 4,6,USUvd(6,4),'USQMIX_{46}'
      write(lhaout,53) 5,1,USUvd(1,5),'USQMIX_{51}'
      write(lhaout,53) 5,2,USUvd(2,5),'USQMIX_{52}'
      write(lhaout,53) 5,3,USUvd(3,5),'USQMIX_{53}'
      write(lhaout,53) 5,4,USUvd(4,5),'USQMIX_{54}'
      write(lhaout,53) 5,5,USUvd(5,5),'USQMIX_{55}'
      write(lhaout,53) 5,6,USUvd(6,5),'USQMIX_{56}'
      write(lhaout,53) 6,1,USUvd(1,6),'USQMIX_{61}'
      write(lhaout,53) 6,2,USUvd(2,6),'USQMIX_{62}'
      write(lhaout,53) 6,3,USUvd(3,6),'USQMIX_{63}'
      write(lhaout,53) 6,4,USUvd(4,6),'USQMIX_{64}'
      write(lhaout,53) 6,5,USUvd(5,6),'USQMIX_{65}'
      write(lhaout,53) 6,6,USUvd(6,6),'USQMIX_{66}'

      write(lhaout,105)
      write(lhaout,51) 'DSQMIX','squark Mixing Matrix'
      write(lhaout,53) 1,1,USDvd(1,1),'DSQMIX_{11}'
      write(lhaout,53) 1,2,USDvd(2,1),'DSQMIX_{12}'
      write(lhaout,53) 1,3,USDvd(3,1),'DSQMIX_{13}'
      write(lhaout,53) 1,4,USDvd(4,1),'DSQMIX_{14}'
      write(lhaout,53) 1,5,USDvd(5,1),'DSQMIX_{15}'
      write(lhaout,53) 1,6,USDvd(6,1),'DSQMIX_{16}'
      write(lhaout,53) 2,1,USDvd(1,2),'DSQMIX_{21}'
      write(lhaout,53) 2,2,USDvd(2,2),'DSQMIX_{22}'
      write(lhaout,53) 2,3,USDvd(3,2),'DSQMIX_{23}'
      write(lhaout,53) 2,4,USDvd(4,2),'DSQMIX_{24}'
      write(lhaout,53) 2,5,USDvd(5,2),'DSQMIX_{25}'
      write(lhaout,53) 2,6,USDvd(6,2),'DSQMIX_{26}'
      write(lhaout,53) 3,1,USDvd(1,3),'DSQMIX_{31}'
      write(lhaout,53) 3,2,USDvd(2,3),'DSQMIX_{32}'
      write(lhaout,53) 3,3,USDvd(3,3),'DSQMIX_{33}'
      write(lhaout,53) 3,4,USDvd(4,3),'DSQMIX_{34}'
      write(lhaout,53) 3,5,USDvd(5,3),'DSQMIX_{35}'
      write(lhaout,53) 3,6,USDvd(6,3),'DSQMIX_{36}'
      write(lhaout,53) 4,1,USDvd(1,4),'DSQMIX_{41}'
      write(lhaout,53) 4,2,USDvd(2,4),'DSQMIX_{42}'
      write(lhaout,53) 4,3,USDvd(3,4),'DSQMIX_{43}'
      write(lhaout,53) 4,4,USDvd(4,4),'DSQMIX_{44}'
      write(lhaout,53) 4,5,USDvd(5,4),'DSQMIX_{45}'
      write(lhaout,53) 4,6,USDvd(6,4),'DSQMIX_{46}'
      write(lhaout,53) 5,1,USDvd(1,5),'DSQMIX_{51}'
      write(lhaout,53) 5,2,USDvd(2,5),'DSQMIX_{52}'
      write(lhaout,53) 5,3,USDvd(3,5),'DSQMIX_{53}'
      write(lhaout,53) 5,4,USDvd(4,5),'DSQMIX_{54}'
      write(lhaout,53) 5,5,USDvd(5,5),'DSQMIX_{55}'
      write(lhaout,53) 5,6,USDvd(6,5),'DSQMIX_{56}'
      write(lhaout,53) 6,1,USDvd(1,6),'DSQMIX_{61}'
      write(lhaout,53) 6,2,USDvd(2,6),'DSQMIX_{62}'
      write(lhaout,53) 6,3,USDvd(3,6),'DSQMIX_{63}'
      write(lhaout,53) 6,4,USDvd(4,6),'DSQMIX_{64}'
      write(lhaout,53) 6,5,USDvd(5,6),'DSQMIX_{65}'
      write(lhaout,53) 6,6,USDvd(6,6),'DSQMIX_{66}'


      write(lhaout,105)
      write(lhaout,51) 'SELMIX','Slepton Mixing Matrix'
      write(lhaout,53) 1,1,USLvd(1,1),'SELMIX_{11}'
      write(lhaout,53) 1,2,USLvd(2,1),'SELMIX_{12}'
      write(lhaout,53) 1,3,USLvd(3,1),'SELMIX_{13}'
      write(lhaout,53) 1,4,USLvd(4,1),'SELMIX_{14}'
      write(lhaout,53) 1,5,USLvd(5,1),'SELMIX_{15}'
      write(lhaout,53) 1,6,USLvd(6,1),'SELMIX_{16}'
      write(lhaout,53) 2,1,USLvd(1,2),'SELMIX_{21}'
      write(lhaout,53) 2,2,USLvd(2,2),'SELMIX_{22}'
      write(lhaout,53) 2,3,USLvd(3,2),'SELMIX_{23}'
      write(lhaout,53) 2,4,USLvd(4,2),'SELMIX_{24}'
      write(lhaout,53) 2,5,USLvd(5,2),'SELMIX_{25}'
      write(lhaout,53) 2,6,USLvd(6,2),'SELMIX_{26}'
      write(lhaout,53) 3,1,USLvd(1,3),'SELMIX_{31}'
      write(lhaout,53) 3,2,USLvd(2,3),'SELMIX_{32}'
      write(lhaout,53) 3,3,USLvd(3,3),'SELMIX_{33}'
      write(lhaout,53) 3,4,USLvd(4,3),'SELMIX_{34}'
      write(lhaout,53) 3,5,USLvd(5,3),'SELMIX_{35}'
      write(lhaout,53) 3,6,USLvd(6,3),'SELMIX_{36}'
      write(lhaout,53) 4,1,USLvd(1,4),'SELMIX_{41}'
      write(lhaout,53) 4,2,USLvd(2,4),'SELMIX_{42}'
      write(lhaout,53) 4,3,USLvd(3,4),'SELMIX_{43}'
      write(lhaout,53) 4,4,USLvd(4,4),'SELMIX_{44}'
      write(lhaout,53) 4,5,USLvd(5,4),'SELMIX_{45}'
      write(lhaout,53) 4,6,USLvd(6,4),'SELMIX_{46}'
      write(lhaout,53) 5,1,USLvd(1,5),'SELMIX_{51}'
      write(lhaout,53) 5,2,USLvd(2,5),'SELMIX_{52}'
      write(lhaout,53) 5,3,USLvd(3,5),'SELMIX_{53}'
      write(lhaout,53) 5,4,USLvd(4,5),'SELMIX_{54}'
      write(lhaout,53) 5,5,USLvd(5,5),'SELMIX_{55}'
      write(lhaout,53) 5,6,USLvd(6,5),'SELMIX_{56}'
      write(lhaout,53) 6,1,USLvd(1,6),'SELMIX_{61}'
      write(lhaout,53) 6,2,USLvd(2,6),'SELMIX_{62}'
      write(lhaout,53) 6,3,USLvd(3,6),'SELMIX_{63}'
      write(lhaout,53) 6,4,USLvd(4,6),'SELMIX_{64}'
      write(lhaout,53) 6,5,USLvd(5,6),'SELMIX_{65}'
      write(lhaout,53) 6,6,USLvd(6,6),'SELMIX_{66}'

      endif errspec

 50   format('#',1x,A)
 51   format('BLOCK',1x,A,2x,'#',1x,A)
 52   format(1x,I9,3x,1P,E16.8,0P,3x,'#',1x,A)
 522  format(1x,I9,3x,1P,E16.8,0P,3x,'#',1x,A)
 53   format(1x,I2,1x,I2,3x,1P,E16.8,0P,3x,'#',1x,A)
 54   format('BLOCK',1x,A,1P,E16.8,2x,'#',1x,A)
 55   format(1x,I5,3x,1P,E16.8,0P,3x,'#',1x,A)
 60   format(9x,1P,E16.8,0P,3x,'#',1x,A)
 61   format(1x,I5,3x,A)
 611  format(1x,I5,2x,I5,2x,A)
 62   format(1x,I5,1x,I5,3x,'#',A)
 72   format(1x,I9,3x,1P,E16.8,0P,3x,'#',1x,A)
 105  format('#') 

      close(lhaout)
c -------------------------------------------------------------------------
      end subroutine
!=====================================================================================================

      subroutine readslha(input)

      character line1*6,line2*60                          ! the line buffer
      integer, parameter:: linemax=50              ! max on a line
      real::val(linemax)
      integer ii,k,num,modnum,smnum(10),minparnum(10),counter_sminp
      integer counter_minpar,counter_algopar,algonum(20)
      double precision sminp(10), minpar(10), algopar(20)

      common/slha_modsel/num, modnum
      common/slha_counters/counter_sminp,counter_minpar,counter_algopar
      common/slha_num/smnum,minparnum,algonum
      common/slha_variables/sminp,minpar,algopar
!--------------------------
      do k=1,linemax,1
         val(k)= 0.d0
      end do

      rewind(input)

       domodsel: do
                                                 ! read a line into memory
      read (input, '(a6,a60)', end=999) line1,line2
!      print*, "line number and value ", line1,line2 

!---------Block MODSEL------------

      if(line1(1:5).eq.'Block'.OR.line1(1:5).eq.'BLOCK')then

         if(line2(1:6).eq.'MODSEL')then

            read(input,*) num, modnum
 !           print*,'num and modnum ', num, modnum

            endif

      endif

      enddo domodsel
 999  continue

!-------------Block sminputs---

      counter_sminp = 0

      rewind(input)
      dosminputs:  do
                                                  ! read a line into memory
       read (input, '(a6,a60)', end=1000,err=1000) line1,line2


      if(line1(1:5).eq.'Block'.OR.line1(1:5).eq.'BLOCK')then

         if(line2(1:8).eq.'SMINPUTS')then

            do ii = 1,10

            read(input,*,end=110,err=110) smnum(ii), sminp(ii)
 !           print*,'smnum and sminp ', smnum(ii), sminp(ii)
            counter_sminp = counter_sminp + 1
            
            enddo
            endif

      endif

 110  continue

      enddo dosminputs
 1000 continue


!------------Block minpar

      counter_minpar = 0

      rewind(input)
        dominpar: do
                                                 ! read a line into memory
      read (input, '(a6,a60)', end=1010,err=1010) line1,line2


      if(line1(1:5).eq.'Block'.OR.line1(1:5).eq.'BLOCK')then

         if(line2(1:6).eq.'MINPAR')then

            do ii = 1,10

            read(input,*,end=120,err=120) minparnum(ii), minpar(ii)
 !           print*,'minnum and minpar ', minparnum(ii), minpar(ii)
            counter_minpar = counter_minpar + 1
            
            enddo
            endif

      endif

 120  continue

      enddo  dominpar
 1010  continue

!---------Block SUSEFLAV

      counter_algopar = 0

      rewind(input)
       doalgo: do
                                                 ! read a line into memory
      read (input, '(a6,a60)', end=1020,err=1020) line1,line2


      if(line1(1:5).eq.'Block'.OR.line1(1:5).eq.'BLOCK')then

         if(line2(1:8).eq.'SUSEFLAV')then

            do ii = 1,20

            read(input,*,end=130,err=130) algonum(ii), algopar(ii)
 !           print*,'algonum and algopar ', algonum(ii), algopar(ii)
            counter_algopar = counter_algopar + 1
            
            enddo
            endif

      endif

 130  continue

      enddo doalgo
 1020  continue


      end subroutine


!=================================================================================================
